#version 150
precision highp float;

in vec3 in_Position;
out vec2 uv;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
layout(std140) uniform AudioBlock {
	vec4 audio[64];
};
#define AUDIO(f) audio[int((f)*63.9999)]

#define EPS 1e-2

float geo(vec3 p) {
	vec3 ba = -(abs(p)-10.);
	float d = min(ba.x,min(ba.y,ba.z));
	for (float f = 0.; f < 11.; f++) {
		float ai = pow(.05+f/10.,2.)*.9,
			h = AUDIO(ai).x*10.;
		d = min(d,length(max(abs(p-vec3((f-5.)*1.6,h-10.,0))-vec3(.5,h,.5),0.)));
	}
	return d;
}

void vert() {
	uv = in_Position.xy*vec2(screenX/screenY,1);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	vec3 rp = vec3(0,-3,-9),
		rd = normalize(vec3(uv,1.));
	
	for (int i = 0; i < 32; i++) {
		float dst = geo(rp);
		if (dst <= 0.) break;
		rp += rd*(dst+EPS);
	}
	
	vec3 nrm = normalize(vec3(geo(rp+vec3(EPS,0,0)),geo(rp+vec3(0,EPS,0)),geo(rp+vec3(0,0,EPS)))-geo(rp));
	float l = 0.;
	for (float f = 0.; f < 11.; f++) {
		float ai = pow(.05+f/10.,2.)*.9,
			h = AUDIO(ai).x*10.;
		vec3 bp = abs(rp-vec3((f-5.)*1.6,h-10.,0))-vec3(.5,h,.5);
		float d = length(max(bp,0.));
		l += (1.+h)/(1.+d);
	}
	gl_FragColor = vec4(l*.05);
}
