#version 150
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
layout(std140) uniform AudioBlock {
	vec4 audio[64];
};
#define AUDIO(f) audio[int((f)*63.9999)]

#define EPS 2e-2

float geo(vec3 p) {
	vec2 sp = floor(abs(p.xz)/10.);
	p.xz = mod(abs(p.xz),10.)-5.;
	float d = p.y;
	for (float x = -1.; x < 2.; x++) {
		for (float z = -1.; z < 2.; z++) {
			vec2 lp = sp+vec2(x,z);
			d = min(d,length(max(abs(p-vec3(x,0,z)*10.)-
			vec3(2.,15.*(1.+dot(sin(lp*2.344),cos(lp.yx*23.932))),2.),0.)));
		}
	}
	return min(10.,d);
}

vec4 bg(vec3 rd) {
	return mix(vec4(.01,0.,.3,1),vec4(2.,1.5,.1,1.),pow(rd.y*-.5+.5,1.5));
}

void vert() {
	uv = in_Position.xy*vec2(screenX/screenY,1);
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	vec3 rp = vec3(0,5.,time*4.),
		rd = normalize(vec3(uv,1.));
	float dst;
	
	for (int i = 0; i < 64; i++) {
		dst = geo(rp);
		if (dst <= 0.) break;
		rp += rd*(dst+EPS);
	}
	
	vec3 nrm = normalize(vec3(geo(rp+vec3(EPS,0,0))-geo(rp-vec3(EPS,0,0)),
							  geo(rp+vec3(0,EPS,0))-geo(rp-vec3(0,EPS,0)),
							  geo(rp+vec3(0,0,EPS))-geo(rp-vec3(0,0,EPS))));
	if (dst <= 0.) {
		vec4 c,l = vec4(0);
		if (rp.y > 0.) {
			c = vec4(.3,.3,.3,1);
			vec3 p = mod(abs(rp),.8)-.4,
				sp = floor(abs(rp)/.8);
			float ai = fract(dot(sp,vec3(1./128.,1./64.,1./8.)));
			l += max(0.,1.-length(max(abs(p)-AUDIO(ai).x*.2,0.))*10.);
		} else c = vec4(.7,.7,.7,1);
		gl_FragColor = c*bg(pow(1.-rd.xzy,vec3(.25)))+l;
	} else gl_FragColor = bg(rd);
}
