#version 150
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
layout(std140) uniform AudioBlock {
	vec4 audio[64];
};
#define AUDIO(f) audio[int((f)*63.9999)]

#define EPS 1e-2

mat2 r2(float a) {
	float s = sin(a), c = cos(a);
	return mat2(c,-s,s,c);
}

float geo(vec3 p) {
	#define bx(o,s) d = min(d,length(max(abs(p-o)-s,0.)))
	vec3 ba = -(abs(p)-10.);
	float d = min(length(p)-2.5,min(ba.x,min(ba.y,ba.z)));
	bx(vec3(0,1.6+AUDIO(0.85).w*5.,0),vec3(1,AUDIO(.85).w*5.,1));
	bx(vec3(1.6+AUDIO(0.1).y*5.,0,0),vec3(AUDIO(.1).y*5.,1,1));
	bx(vec3(0,0,1.6+AUDIO(0.2).y*5.),vec3(1,1,AUDIO(.2).y*5.));
	bx(vec3(0,-1.6+AUDIO(0.3).y*-5.,0),vec3(1,AUDIO(.3).y*5.,1));
	bx(vec3(-1.6+AUDIO(0.4).y*-5.,0,0),vec3(AUDIO(.4).y*5.,1,1));
	bx(vec3(0,0,-1.6+AUDIO(0.5).y*-5.),vec3(1,1,AUDIO(.5).y*5.));
	#undef bx
	return d-.2;
}

void vert() {
	time = float(frame)/float(framerate);
	uv = in_Position.xy*vec2(screenX/screenY,1);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	vec3 rp = vec3(0,0,-9),
		rd = normalize(vec3(uv,1.));
	
	mat2 cr = r2(time);
	rp.xz *= cr;
	rd.xz *= cr;
	cr = r2(time*.6);
	rp.yz *= cr;
	rd.yz *= cr;
	
	for (int i = 0; i < 32; i++) {
		float dst = geo(rp);
		if (dst <= 0.) break;
		rp += rd*(dst+EPS);
	}
	
	vec3 nrm = normalize(vec3(geo(rp+vec3(EPS,0,0)),geo(rp+vec3(0,EPS,0)),geo(rp+vec3(0,0,EPS)))-geo(rp));
	vec3 l = vec3(0);
	#define bx(c,o,s) l += c*dot(s,vec3(1))/(1.+length(max(abs(rp-o)-s,0.)))
	bx(vec3(1,0.4,0.6),vec3(0,1.6+AUDIO(0.85).w*5.,0),vec3(1,AUDIO(.85).w*5.,1));
	bx(vec3(0,1,0),vec3(1.6+AUDIO(0.1).y*5.,0,0),vec3(AUDIO(.1).y*5.,1,1));
	bx(vec3(0,0,1),vec3(0,0,1.6+AUDIO(0.2).y*5.),vec3(1,1,AUDIO(.2).y*5.));
	bx(vec3(1,0,1),vec3(0,-1.6+AUDIO(0.3).y*-5.,0),vec3(1,AUDIO(.3).y*5.,1));
	bx(vec3(0,1,1),vec3(-1.6+AUDIO(0.4).y*-5.,0,0),vec3(AUDIO(.4).y*5.,1,1));
	bx(vec3(1,1,0),vec3(0,0,-1.6+AUDIO(0.5).y*-5.),vec3(1,1,AUDIO(.5).y*5.));
	gl_FragColor = vec4(l*.2,1);
}
