#version 150
precision highp float;

in vec3 in_Position;
out vec2 uv;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
layout(std140) uniform AudioBlock {
	vec4 audio[64];
};
#define AUDIO(f) audio[int((f)*63.9999)]

vec4 hash(vec4 a) {
	return fract(abs(sin(a.ywxz*766.345)+cos(normalize(a)*4972.92855))*2048.97435+abs(a.wxyz)*.2735);
}

void vert() {
	uv = in_Position.xy*vec2(screenX/screenY,1);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	float s = 0.;
	for (float p = 1.; p < 40.; p++) {
		vec4 pp = hash(p*vec4(.01,.1,1.,10.));
		s += cos(length(uv.xy-(pp.xy*2.-1.))*p*p)*pow(AUDIO(p/40.).x,4.)/p;
	}
	gl_FragColor = vec4(abs(s)*5.);
}
