#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

vec3 hsvToRGB(vec3 hsv) {
	return mix(clamp(abs(mod(hsv.x*6.0+vec3(0.,4.,2.),6.)-3.0)-1.0,0.,1.),vec3(1),hsv.y)*hsv.z;
}

#define iterations 2

void vert() {
	uv = in_Position.xy*.5+.5;
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	float res = 1.;
    for (int i = 0; i < iterations; i++) {
        res += cos(uv.y*12.345 - time*4. + cos(res*12.234)*.2 + cos(uv.x*32.2345 + cos(uv.y*17.234)) ) + cos(uv.x*12.345);
    }
        
    vec3 c = hsvToRGB(vec3(res*.6,0,0.8));
	//vec3 c = mix(vec3(1.,0.,0.),
    //             vec3(.6,.2,.2),
    //            cos(res+cos(uv.y*24.3214)*.1+cos(uv.x*6.324+time*4.)+time)*.5+.5);
    
    c = mix(c,
            vec3(0.),
            clamp( (length(uv-.5 + cos(time+uv.yx*4.34+uv.xy*res)*.1 )*5.-.4) , 0., 1.) );
    
    gl_FragColor = vec4(c,length(c));
}
