#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

float hash(vec2 p) {
    return fract(dot(p+vec2(.36834,.723), normalize(fract(p.yx*73.91374)+1e-4))*7.38734);
}

void vert() {
	uv = in_Position.xy*vec2(screen.x/screen.y,1);
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	vec3 ro = vec3(sin(time*.04)*8.,cos(time*.06)*5.,time), rd = normalize(vec3(uv,1.));
    vec4 s = vec4(0.);
    for (float j = 1.; j < 32.; j++) {
        float i = pow(j,1.6);
        vec3 p = abs(ro+rd*(i+hash(uv*screen+i))),
            lp = mod(p,20.)-10., fp = floor(p/20.);
        float ld = 1e6,
        d = length(lp)-8.;
        float la1 = atan(lp.y,lp.x)+time;
        s += vec4(sin(la1+fp.z*2.2834),cos(la1+fp.x*.73973),-sin(la1+fp.y*.8594),1)*.08*max(0.,2.-abs(d));
        if (s.w >= 1.) break;
    }
    gl_FragColor = mix(vec4(0),s,s.w);
}
