#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

mat2 rot2d(float a) {
    float s = sin(a), c = cos(a);
    return mat2(c,s,-s,c);
}
float checker(vec2 u) {
	return mod(floor(u.x)+floor(u.y),2.);
}

void vert() {
	uv = (in_Position.xy*.5+.5)*vec2(screen.x/screen.y,1);
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	vec2 p = uv;
    float ls = 1., n = 0.;
    for (float s = 2.; s < 16.; s += s) {
        p *= s;
        vec2 iv = floor(p/ls);
        ls = s;
        if (mod(iv.x+iv.y,2.) < 1.) {
            p = abs((fract(p)-.5)*rot2d(s+iv.x+iv.y*9.874))*2.;
            n++;
        }
    }
    gl_FragColor = vec4(checker(p*.2));
}
