#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

//prefix 's' = signed, 'u' = unsigned, credits to inigo quilezles http://iquilezles.org/www/articles/distfunctions/distfunctions.htm
float scircle(vec2 p, float r) {
	return length(p)-r;
}
float usquare(vec2 p, vec2 s) {
	return length(max(abs(p)-s,0.));
}
float ssquare(vec2 p, vec2 s) {
	vec2 a = abs(p)-s;
	return min(max(a.x,a.y),0.)+length(max(a,0.));
}
float sring(vec2 p, vec2 r) {
	return abs(length(p)-r.x)-r.y;
}
float storus(vec3 p, vec2 r) {
	return length(vec2(length(p.xz)-r.x,p.y)-r.y);
}

/*
float sdHexPrism( vec3 p, vec2 h )
{
    vec3 q = abs(p);
    return max(q.z-h.y,max((q.x*0.866025+q.y*0.5),q.y)-h.x);
}*/
float shex(vec2 p, float h)
{
	vec2 a = abs(p);
	return max((a.x*0.866025+a.y*0.5),a.y)-h;
}

/*
float sdTriPrism( vec3 p, vec2 h )
{
    vec3 q = abs(p);
    return max(q.z-h.y,max(q.x*0.866025+p.y*0.5,-p.y)-h.x*0.5);
}*/
float stri(vec2 p, float h)
{
	return max((abs(p.x)*0.866025+p.y*0.5),-p.y)-h;
}

/*
float sdCapsule( vec3 p, vec3 a, vec3 b, float r )
{
    vec3 pa = p - a, ba = b - a;
    float h = clamp( dot(pa,ba)/dot(ba,ba), 0.0, 1.0 );
    return length( pa - ba*h ) - r;
}*/
float sline(vec2 p, vec2 a, vec2 b, float r) {
	vec2 pa = p-a, ba = b-a;
	return length(pa-ba*clamp(dot(pa,ba)/dot(ba,ba),0.,1.))-r;
}

/*
float dot2( in vec3 v ) { return dot(v,v); }
float udTriangle( vec3 p, vec3 a, vec3 b, vec3 c )
{
    vec3 ba = b - a; vec3 pa = p - a;
    vec3 cb = c - b; vec3 pb = p - b;
    vec3 ac = a - c; vec3 pc = p - c;
    vec3 nor = cross( ba, ac );

    return sqrt(
    (sign(dot(cross(ba,nor),pa)) +
     sign(dot(cross(cb,nor),pb)) +
     sign(dot(cross(ac,nor),pc))<2.0)
     ?
     min( min(
     dot2(ba*clamp(dot(ba,pa)/dot2(ba),0.0,1.0)-pa),
     dot2(cb*clamp(dot(cb,pb)/dot2(cb),0.0,1.0)-pb) ),
     dot2(ac*clamp(dot(ac,pc)/dot2(ac),0.0,1.0)-pc) )
     :
     dot(nor,pa)*dot(nor,pa)/dot2(nor) );
}

// exponential smooth min (k = 32);
float smin( float a, float b, float k )
{
    float res = exp( -k*a ) + exp( -k*b );
    return -log( res )/k;
}
// polynomial smooth min (k = 0.1);
float smin( float a, float b, float k )
{
    float h = clamp( 0.5+0.5*(b-a)/k, 0.0, 1.0 );
    return mix( b, a, h ) - k*h*(1.0-h);
}
// power smooth min (k = 8);
float smin( float a, float b, float k )
{
    a = pow( a, k ); b = pow( b, k );
    return pow( (a*b)/(a+b), 1.0/k );
}
*/

void vert() {
	uv = (in_Position.xy*.5+.5)*vec2(screen.x/screen.y,1);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	float o = 1e7;
	vec2 tp = floor(uv*3.), lp = uv*3.-tp-.5;
	int ti = int(tp.x+tp.y*3.);
	if (ti == 0) o = scircle(lp,.2);
	else if (ti == 1) o = ssquare(lp,vec2(.2,.1));
	else if (ti == 2) o = sring(lp,vec2(.2,.04));
	else if (ti == 3) o = stri(lp,.15);
	else if (ti == 4) o = shex(lp,.3);
	else if (ti == 5) o = stri(lp,.15);
	else if (ti == 6) o = sline(lp,vec2(-.4,-.4),vec2(.2,.45),.02);
	o = max(1.-o*screen.x*.2,0);
	gl_FragColor = vec4(o,o,o,1);
}
