#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

float voronoi(vec2 u, float i) {
	#define l(i) length(fract(abs(u)*.01+fract(i*vec2(1,8))+cos(u.yx*fract(time*.02)*.07+i*8.))-.5)
	return l(i);
}

//#define NORMAL_PRECISION 1e4

void vert() {
	uv = in_Position.xy*vec2(screenX/screenY,1);
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	vec2 u = uv.xy*300.0;
	vec3 o = vec3(0.),
		lpos = vec3(sin(time*.2), 0.01, cos(time*.3)),
		wpos = vec3(uv.x, 0., uv.y),
		rpos = lpos-wpos,
		rdir = normalize(rpos);
	for (int i = 0; i < 10; i++) {
		float mo = float(i + 1) / 10.0,
			dst = voronoi(u, mo),
			NORMAL_PRECISION = .1+pow(mo,.5)*1e2;
		vec3 nrm = normalize(vec3(voronoi(u + vec2(NORMAL_PRECISION, 0), mo) - dst, NORMAL_PRECISION*.01, voronoi(u + vec2(0, NORMAL_PRECISION), mo) - dst));
		o += vec3(max(0.,1.-dst*2.)*(.2+max(0., dot(rdir, nrm))) / (1.+length(rpos)*10.));
	}
	gl_FragColor = vec4(o+max(0.,2.-length(wpos.xz-lpos.xz)*50.), 1);
}

/*
float dst1 = voronoi(u,0.1), dst2 = voronoi(u,.3), dst, mo;
if (dst1 < dst2) {
dst = dst1;
mo = 0.1;
}
else {
dst = dst2;
mo = 0.3;
}
vec3 nrm = normalize(vec3(voronoi(u + vec2(NORMAL_PRECISION, 0),mo) - dst, NORMAL_PRECISION*.01, voronoi(u + vec2(0, NORMAL_PRECISION),mo) - dst)),

rpos = lpos-wpos;
gl_FragColor = vec4(max(0., 2. - length(wpos.xz - lpos.xz)*20.)+(max(0., dot(nrm, normalize(rpos)))*4. / (1. + length(rpos)*10.))*max(0., 1. - dst*2.));
*/
