#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv,px;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};

uniform sampler2D Buffer0,Image;

void vert() {
	uv = in_Position.xy*.5+.5;
	px = uv*vec2(screenX, screenY);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	if (frame == 0) {
		gl_FragColor = texture2D(Image, uv);
	}
	else {
		float dir = mod(floor(px.y)+frame, 2.)*2. - 1.,
			s0 = texture2D(Buffer0, uv).x,
			s1 = texture2D(Buffer0, uv+vec2(0,dir/vec2(screenX,screenY))).x;
		if (dir > 0.) {
			if (s1 > s0) s0 = s1;
		}
		else {
			if (s0 > s1) s0 = s1;
		}
		gl_FragColor = vec4(s0);
	}
}
