#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenWidth,screenHeight;
	int frame, framerate;
};

uniform sampler2D Buffer;

float triwave(float x) {
	return x*2.-max(0.,x*4.-2.);
}

void vert() {
	uv = in_Position.xy*vec2(screenWidth/screenHeight,1);
	time = (float(frame)/float(framerate));
	gl_Position = vec4(in_Position.xy,0,1);
}
void frag() {
	float t1 = fract(time*.2)*10.,
	t2 = fract(time*.2+0.5)*10.;
	float g1 = length(max(abs(mod(abs(uv)*t1*t1,2.)-1.)-.8,0.)),
		g2 = length(max(abs(mod(abs(uv)*t2*t2,2.)-1.)-.8,0.)),
		s1 = max(.4,(1.0-t1*.1*.6)-g1*10.),
		s2 = max(.4,(1.0-t2*.1*.6)-g2*10.);
	gl_FragColor = vec4(mix(s1,s2,clamp((triwave(fract(time*.2+0.5))*2.-1.)*2.,-1.,1.)*.5+.5));
}
