#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

mat2 rot2(float a) {
	float s = sin(a), c = cos(a);
	return mat2(c,s,-s,c);
}
float usquare(vec2 p, vec2 s) {
	return length(max(abs(p)-s,0.));
}

float tree(vec2 p, float n, float w) {
	float y = p.y*n, b = floor(y), x = pow(2.,b),
	 s = p.x*x, i = floor(s),
	 rot = (mod(i,2.)-.5);
	vec2 uv = vec2(s-i,y-b)*2.-1.;
	uv.x /= 1.-(uv.y*.5+.5)*max(0.,w-.175)/(w/.45);
	if (b > .5) {
		if (w < .175) uv.x += rot*(1.-(uv.y*.5+.5))*(1.-w/.175)*.35;
		uv *= rot2(rot*-.25*3.14);
		uv.x += rot*.77;
	}
	return usquare(uv,vec2(w,2.))/x;
}

void vert() {
	uv = in_Position.xy*.5+.5;
	gl_Position = vec4(in_Position,1);
}
void frag() {
	float time = fract(float(frame)/float(framerate)*.1);
	gl_FragColor = vec4(max(tree(uv,2.+time*4.,.001+time*.1),uv.y-time)*10.);
}
