#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

float voronoi(vec2 uv) {
    vec2 lp = abs(uv)*10.;
    vec2 sp = fract(lp)-.5;
    lp = floor(lp);
    
    float d = 1.;
    
    for (int x = -1; x < 2; x++) {
        for (int y = -1; y < 2; y++) {
            
            vec2 mp = vec2(float(x),float(y));
            vec2 p = lp+mp;
            
            d = min(d,length(sp+(cos(p.x+time)+cos(p.y+time))*.3-mp));
            
        }
    }
    
    return d;
}

void vert() {
	uv = in_Position.xy*vec2(screen.x/screen.y,1);
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
    float ang = atan(uv.y,uv.x);
    float dst = length(uv);
    float cfade = clamp(dst*40.-3.+cos(ang*1.+cos(ang*6.)*1.+time*2.)*.68,0.,1.);
    
    float a = 0.;
    for (int i = 3; i < 6; i++) { 
        float fi = float(i);
        vec2 luv = uv+cos((ang-dst)*fi+time+uv+fi)*.2;
    
    	a += voronoi(luv)*(.7+(cos(luv.x*14.234)+cos(luv.y*16.234))*.4);
    }
    vec3 color = vec3(0.16, .57 ,.19);
    
	gl_FragColor = vec4(color*a*cfade,1.);
}
