#version 330
precision highp float;

in vec3 in_Position;
out vec2 uv;
out float time;

layout(std140) uniform ShaderviewBlock {
	vec4 mouse;
	float screenX,screenY;
	int frame,framerate;
};
#define screen vec2(screenX,screenY)

float voronoi(vec2 u, float i) {
	#define l(i) length(fract(abs(u*.01+fract(i*vec2(1,8))+sin(u.yx*.2+i*8.)*.02+sin(u*.06+1.6+i*6.)*.1))-.5)
	return l(i);
}
float triwave(float t) {
	return t*2.-max(0.,t*4.-2.);
}

void vert() {
	uv = in_Position.xy*vec2(screenX/screenY,1);
	time = float(frame)/float(framerate);
	gl_Position = vec4(in_Position,1);
}
void frag() {
	float s = 0.,scal = 10.+triwave(fract(time*.02))*200.;
	for (int i = 0; i < 8; i++) {
		s += (sin(voronoi(uv*scal*float(i+1),float(i)/8.0)*pow(float(i+2),2.)-time*pow(float(i+1),1.2))*.5+.5)/float(i+1);
	}
	s = pow(s*.35,2.);
	gl_FragColor = vec4(s,s,s,1);
}
